package final_risk;

import java.util.Observable;
import java.util.Random;


// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.9D0AAB00-4900-8A15-5DC0-891219723F00]
// </editor-fold> 
public class Dados extends Observable {

    private int valorCara_def1;
    private int valorCara_def2;

    private int valorCara_ataq1;
    private int valorCara_ataq2;
    private int valorCara_ataq3;

    public Dados() {
        this.valorCara_def1 = 0;
        this.valorCara_def2 = 0;
        this.valorCara_ataq1 = 0;
        this.valorCara_ataq2 = 0;
        this.valorCara_ataq3 = 0;
    }

    public int getValorCara_ataq1() {
        return valorCara_ataq1;
    }

    public int getValorCara_ataq2() {
        return valorCara_ataq2;
    }

    public int getValorCara_ataq3() {
        return valorCara_ataq3;
    }

    public int getValorCara_def1() {
        return valorCara_def1;
    }

    public int getValorCara_def2() {
        return valorCara_def2;
    }

    public void tirarDado(int num_ata, int num_def) {

        Random rnd = new Random();


        this.valorCara_def1 = rnd.nextInt(6) + 1;
        this.valorCara_def2 = rnd.nextInt(6) + 1;
        this.valorCara_ataq1 = rnd.nextInt(6) + 1;
        this.valorCara_ataq2 = rnd.nextInt(6) + 1;
        this.valorCara_ataq3 = rnd.nextInt(6) + 1;
        
        if (num_ata != 1)
            Ordenar_Ataque();
        
        if (num_def != 1)
            Ordenar_Defesor();
        
        setChanged();
        notifyObservers((Object)"Resultado_Dados");        
    }

    private void Ordenar_Ataque () {
        int ord_ata[]= new int[3];

        ord_ata[0]= this.valorCara_ataq1;
        ord_ata[1]= this.valorCara_ataq2;
        ord_ata[2]= this.valorCara_ataq3;
       
        Burbuja(ord_ata,3);

        this.valorCara_ataq1= ord_ata[0];
        this.valorCara_ataq2= ord_ata[1];
        this.valorCara_ataq3= ord_ata[2];
    }
    
    private void Burbuja(int []vector , int nelem){
        for(int i=0; i<nelem-1; i++)
            for(int j=nelem-1; j>i; j--)
                if(vector[j]>vector[i])
                    intercambiar(vector,i,j);
    }

    private void Ordenar_Defesor() {
        int aux_def= 0;
        
        if (this.valorCara_def1 < this.valorCara_def2){
            aux_def= this.valorCara_def2;
            this.valorCara_def2= this.valorCara_def1;
            this.valorCara_def1= aux_def;
        }
    }
    
    private void intercambiar (int []vector,int x, int y) {
        int aux = vector[x];
        vector[x]=vector[y];
        vector[y]=aux;
    }    
}
